﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Examples.Master" Inherits="System.Web.Mvc.ViewPage<IEnumerable<RegionInfo>>" %>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <% Html.Telerik().GoogleMap()
                .Name("map")
                .Width(880)
                .Height(600)
                .Latitude(40)
                .Longitude(-3)
                .EnableMarkersClustering(options =>
                {
                    options.MaxZoom = (int)ViewData["MaxZoom"];
                    options.GridSize = (int)ViewData["GridSize"];
                    options.AverageCenter = (bool)ViewData["AverageCenter"];
                    options.ZoomOnClick = (bool)ViewData["ZoomOnClick"];
                    options.HideSingleGroupMarker = (bool)ViewData["HideSingleGroupMarker"];
                    if ((string)ViewData["CustomStyles"] == "StackOverflow")
                    {
                        options.CustomStyles.Add(new MarkerClusteringStyles { Url = "/Images/cluster1.png", Height = 35, Width = 35, TextSize = 12, TextColor = Color.White });
                        options.CustomStyles.Add(new MarkerClusteringStyles { Url = "/Images/cluster2.png", Height = 45, Width = 45, TextSize = 12, TextColor = Color.White });
                        options.CustomStyles.Add(new MarkerClusteringStyles { Url = "/Images/cluster3.png", Height = 60, Width = 60, TextSize = 12, TextColor = Color.White });
                        options.CustomStyles.Add(new MarkerClusteringStyles { Url = "/Images/cluster3.png", Height = 60, Width = 60, TextSize = 12, TextColor = Color.White });
                        options.CustomStyles.Add(new MarkerClusteringStyles { Url = "/Images/cluster3.png", Height = 60, Width = 60, TextSize = 12, TextColor = Color.White });
                    }
                })
                .BindTo<RegionInfo, Marker>
                (Model, mappings => mappings.For<RegionInfo>
                        (
                            binding => binding.ItemDataBound
                            (
                                (marker, obj) =>
                                {
                                    marker.Latitude = obj.Latitude;
                                    marker.Longitude = obj.Longitude;
                                }
                            )
                        )
                ).Render();%>
    <% using (Html.Configurator("Google Map Settings")
              .PostTo("MarkerClustering", "Marker")
              .Begin())
       { %>
    <ul>
        <li>
            <%= Html.CheckBox("AverageCenter", false, "Average center")%>
        </li>
        <li>
            <label for="MaxZoom">
                Max Zoom
            </label><br />
            <%= Html.Telerik().DropDownList()
                            .Name("MaxZoom")
                            .SelectedIndex(0)
                            .BindTo(new SelectList(new[] { 7, 8, 9, 10, 11, 12 }))%>
             
        </li>
    </ul>
    <ul>
        <li>
            <%= Html.CheckBox("ZoomOnClick", true, "Zoom on click")%>
        </li>
        <li>
            <label for="GridSize">
                Grid Size
            </label><br />
            <%=Html.Telerik().DropDownList()
                            .Name("GridSize")
                            .SelectedIndex(0)
                            .BindTo(new SelectList(new[] {5,10,20,30, 40, 50, 60, 70, 80 }))%>
        </li>
    </ul>
    <ul>
        <li>
            <%= Html.CheckBox("HideSingleGroupMarker", true, "Hide single group marker")%></li>
             <li>
            <label for="CustomStyles">
               Custom Styles
            </label><br />
            <%=Html.Telerik().DropDownList()
                            .Name("CustomStyles")
                            .SelectedIndex(0)
                            .BindTo(new SelectList(new[] { "Default", "StackOverflow" }))%>
        </li>
    </ul>
    <br />    
    <button class="t-button t-state-default" type="submit">Apply</button>
    
    <% } %>
</asp:Content>
