﻿using System.Drawing;
using System.IO;
using System.Web.UI;
using Jmelosegui.Mvc.Controls.Overlays;
using Moq;
using Xunit;

namespace Jmelosegui.Mvc.Controls.Tests
{
    public class PolygonsTest
    {
        private readonly GoogleMap map;
        private readonly GoogleMapBuilder controlBuilder;

        public PolygonsTest()
        {
            var writer = new Mock<HtmlTextWriter>(TextWriter.Null);
            map = GoogleMapTestHelper.CreateMap(writer.Object);
            controlBuilder = new GoogleMapBuilder(map);
        }

        [Fact]
        public void Add_New_Polygon_increase_PolygonsCollection()
        {
            controlBuilder.Polygons(p => p.Add()
                                            .Points(ptn =>
                                                        {
                                                            ptn.Add(23, 80);
                                                            ptn.Add(23, 90);
                                                            ptn.Add(50, 80);
                                                            ptn.Add(23, 80);
                                                        })
                                     );

            Assert.NotNull(map.Polygons);
            Assert.True(map.Polygons.Count == 1);
            Assert.True(map.Polygons[0].Points.Count == 4);
        }

        [Fact]
        public void Call_A_Method_From_ShapeBuilder_Return_A_Derivedclass()
        {
            var builder = new PolygonBuilder(new Polygon(map));

            Assert.IsType(typeof(PolygonBuilder), builder.FillColor(Color.Red));
        }
    }
}
