﻿using System.Web.Mvc;
using System.Web.Routing;
using Telerik.Web.Mvc;

namespace Mvc.Googlemap.Examples
{
    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "FirstLook", id = UrlParameter.Optional } // Parameter defaults
            );
        }

        protected void Application_Start()
        {
#if MVC3
            ViewEngines.Engines.Clear();
            ViewEngines.Engines.Add(new RazorViewEngine());
            ViewEngines.Engines.Add(new WebFormViewEngine());

            AreaRegistration.RegisterAllAreas();
#endif
            RegisterRoutes(RouteTable.Routes);
            SiteMapManager.SiteMaps.Register<XmlSiteMap>("examples", sitmap => sitmap.Load());
        }
    }
}